#!/usr/bin/perl -w
#
# Output a selection of channels on one page
# (c) Andrew Flegg 2000. Released under the Artistic Licence.

use strict;
use CGI;
use lib "/home/jaffa/bin/tv";
#use lib "/dcs/97/csube/tmp/tv";
use Telly;

my $query    = new CGI;
my @headings = ("bbc1", "bbc2", "itv", "ch4", "ch5");
my $inclDesc = $query->param("desc");
my $time     = 0;
my %nice     = ();

foreach my $file (@headings) {
    my $fname = "$Telly::DATA/$file.pm";

    $file =~ s/[^A-Za-z0-9_]//g;

    do "$fname" if (-f $fname);
    $nice{$file} = Telly::niceChannelName($file);
    $time        = (stat($fname))[9];
}

my $num   = $#headings + 1;
my $other = ($inclDesc ? 0 : 1);
my $date  = scalar(gmtime($time));
$date     =~ s/^(\w+)\s+(\w+)\s+(\d+).*?\s+(\d+)$/$1, $3 $2 $4/;

print <<EOH;
Content-type: text/html

<html>
<head>
<title>Today's Telly Listings</title>

<style type="text/css"><!--
  body { margin:0px; }
  h1 {
    font-family: arial, helvetica, homerton, sans-serif;
    font-size: 200%;
    margin-bottom: 0px;
    padding-bottom: 0px;
  }

  .choice {
    font-family: arial, helvetica, homerton, sans-serif;
    font-size: 85%;
    font-weight: bold;
  }

  .msg {
    font-family: times, trinity, serif;
    font-size: 75%;
    margin-left: 30%;
    text-align: right;
  }
--></style>

</head>

<body bgcolor="#ffffff" text="#000000" link="#0000FF" vlink="#008080"
alink="#00ff00" marginwidth=0 marginheight=0 style="margin:0px;">
<table border=0 cellspacing=0 cellpadding=8>
<tr><td bgcolor="#ffd884" valign="middle" align="center" colspan=$num>
<h1>All Channels</h1>
<small><a href="/tv/">Home</a>&nbsp;|&nbsp;
$date&nbsp;|&nbsp;
<a href="all.cgi?desc=$other">Toggle Descriptions</a></small>
</td></tr>

<tr>
EOH

# ------------------------------------------------------------------
my @colours = ("ffeeaa", "fff0bb");
my $colour  = 0;

my $fnt = '<font face="Arial,Helvetica,Homerton" size=2>';
foreach my $i (@headings) {
    my @chnl = @{ $Telly::LISTINGS{$i} };
    print '<td bgcolor="#'.$colours[$colour].'" valign="top">';
    print "<b><a href=\"/cgi-bin/tv/channel.cgi?channel=$i\">$nice{$i}</b><br>\n";
    print "<table cellpadding=0 cellspacing=2 border=0>";
    foreach my $j (@chnl) {
	my ($time, $title, $desc) = @{ $j };
	my $bg = "";
	$bg = ' bgcolor="#dddddd"' if ($desc =~ m!(Film)!i);
	print"<tr><td valign=\"top\">$fnt<b>".niceTime($time).
	    "</b></font></td>\n<td$bg>$fnt";

	if ($inclDesc) {
            print "<b>$title</b> $desc";
        } else {
            print "$title";
        }
	print "</font></td></tr>\n";
    }
    print "</table>\n</td>\n\n";
    $colour = 1 - $colour;
}
# ------------------------------------------------------------------

print <<EOH;
</tr>
</table>

<p class="msg">&copy; Andrew Flegg 2000. All rights reserved.<br>
This content is sourced from publically available content on the
Internet.<br>
Please <a href="mailto:andrew\@bleb.org">send</a> any suggestions to me.
The original pages are at <a 
href="http://www.bleb.org/tv/">Bleb.org</a>.</p>
EOH

exit;

#-- Oops, die ---------------------------
sub error {
    return "You fscked up!";
}
